INTERFACE WSObjectVBT;

(* A WSObjectVBT.T (workspace object VBT) represents something
   that can appear in the workspace and contain documents, a
   DeckVBT.T or a FreeDocVBT.T. *)

IMPORT DocVBT, FormsVBT, VBT;

TYPE
  T <: Public;
  Public = FormsVBT.T OBJECT 
  METHODS
    addDoc(doc: DocVBT.T);  (* Adds a document to the WSObjectVBT. *)
    remDoc(doc: DocVBT.T);  (* Removes a document from the WSObjectVBT. *)
    replaceDoc(old, new: DocVBT.T);  (* Useful for reload. *)
    getWorkspace(): VBT.T;  (* Really returns a workspace. *)
  END;
(* None of these methods have defaults; subtypes of a WSObjectVBT
   must provide them.  The FormsVBT.T mouse method is overriden
   to trap right mouse clicks to raise the object to the 'top'
   (if any of it is obscured) or to 'bottom' the object
   (otherwise). *)

END WSObjectVBT.
